//-----------------------------------------------------------------------
//	main.cpp
//-----------------------------------------------------------------------
#include<iostream>
#include<stdio.h>
#include<string.h>
#include<termios.h>
#include<fcntl.h>
#include<unistd.h>
#include<stdlib.h>
#include<math.h>
//-----------------------------------------------------------------------
#define classe_e 
#include<main.h>
#undef classe_e

#define classe_e extern
#include<commun.h>
#undef classe_e

#define classe_e extern
#include<specifique.h>
#undef classe_e

using namespace std;
//-----------------------------------------------------------------------

FILE *flog;

//-----------------------------------------------------------------------
int main(void)
{
	system("clear");
	
	init();

	debut();
		
	action();

	fin();
			
	return 0;
}
//-----------------------------------------------------------------------
//init
void init(void)
{
}
//-----------------------------------------------------------------------
//fonction action
void action(void)
{
	FILE *f;
	FILE *ftdf;
	int fd;
    struct termios options;
    
    
    //variables de controle
	float va;
	float vg1;
	float vg2;

	//variables mesurees
	float va_mes;
	float vg1_mes;
	float vg2_mes;
	float ia_mes;
	float ig1_mes;
	float ig2_mes;

	
	int ret;
	
	

	//ouverture fichier resultat
	f=fopen("res.dat","w");
	verif(f,"creation fichier res impossible");

	//ouverture fichier resultat tdf
	ftdf=fopen("res.tdf","w");
	verif(ftdf,"creation fichier tdf impossible");

	//ouverture fichier log des commandes (hex)
	flog=fopen("res.log","w");
	verif(flog,"creation fichier log impossible");


	//ouverture port serie (ttys0 pour le port com0 et ttys1 pour le port com1)
	fd = open("/dev/ttyS1", O_RDWR | O_NOCTTY | O_NDELAY);
    tcgetattr(fd, &options);
    cfmakeraw(&options);
	cfsetispeed(&options, B115200);
	cfsetospeed(&options, B115200);
    tcsetattr(fd, TCSANOW, &options);

	if (fd==-1)
	{
		cout<<"ouverture port serie /dev/ttyS1 impossible"<<endl;
	}
	else
	{
		fcntl(fd, F_SETFL, 0);
	}
	


	//envoi des valeurs limites au µtracer
	envoi_cmde(fd,SET_VA_max,400);

	envoi_cmde(fd,SET_VG1_max,0);
	envoi_cmde(fd,SET_VG1_min,-5);

	envoi_cmde(fd,SET_VG2_max,300);
	envoi_cmde(fd,SET_VG2_min,0);

	envoi_cmde(fd,SET_VFIL_max,7);
	envoi_cmde(fd,SET_VFIL_min,5);

	envoi_cmde(fd,SET_IA_max,3.5);
	envoi_cmde(fd,SET_IG1_max,0.001);
	envoi_cmde(fd,SET_IG2_max,0.001);

	envoi_cmde(fd,SET_PWA_max,0.8);
	envoi_cmde(fd,SET_PWG2_max,0.001);
	envoi_cmde(fd,SET_PWG1_max,0.001);

	//programmation de la tension de chauffage
	envoi_cmde(fd,SET_VFIL,6.3);


	//exploration parametrique
	while (true)
	{
		//boucle sur vg1
		for (vg1=-5;vg1<=0;vg1=vg1+0.5)
		{
			//boucle sur va
			for (va=0;va<400;va=va+5)
			{
				//interrogation du µC
				ret=mesure(fd,20,va,0,vg1,&va_mes,&vg2_mes,&vg1_mes,&ia_mes,&ig2_mes,&ig1_mes);
				
				//passage de mA en A
				ia_mes=ia_mes/1000;
				ig1_mes=ig1_mes/1000;
				ig2_mes=ig2_mes/1000;

				//si pas de limitations renvoyée par le µC
				if (ret==0)
				{
					//ecriture de res.dat
					fprintf
							(
								f,
								"%f %f %f %f %f %f \n",
								va_mes,ia_mes,
								vg1_mes,ig1_mes,
								vg2_mes,ig2_mes
							);				

					//ecriture de res.tdf
					fprintf
							(
								ftdf,
								"%f %f %f %f %f %f \n",
								va_mes,ia_mes,
								vg1_mes,ig1_mes,
								vg2_mes,ig2_mes
							);				

					//ecriture à l'ecran
					fprintf
							(
								stdout,
								"%7.3f %7.6f %7.3f %7.6f %7.3f %7.6f\n",
								va_mes,ia_mes,
								vg1_mes,ig1_mes,
								vg2_mes,ig2_mes
							);				
				}
				
				
				//en cas de limitation
				if (ret!=0)
				{
					printf("limitation: code retour ---> %d\n",ret);
				}
			}
			
			fprintf(f,"\n");
		}
		
		break;
	}


	envoi_cmde(fd,SET_STOP,0);

	fclose(f);
	fclose(ftdf);
	fclose(flog);
	close(fd);
}

//-----------------------------------------------------------------------
//envoi d'une commande
//-----------------------------------------------------------------------
int envoi_cmde(int fd,int cmde,float v)
{
	unsigned char rec;
	unsigned char *addr;

	//pour avoir une copie des octets envoyés
	
	addr=(unsigned char*)&v;
	fprintf(flog,"commande %d valeur %f [%x] [%x %x %x %x]\n",cmde,v,cmde,*addr,*(addr+1),*(addr+2),*(addr+3));
			
	if (1==2)
	{
		printf("\ncommande %d valeur %f\n",cmde,v);
		printf("codage de la commande (en hex) %x\n",cmde);
		printf("codage de la valeur (en hex)   %x %x %x %x\n",*addr,*(addr+1),*(addr+2),*(addr+3));

		//getchar();
	}			
	
	//printf("envoi de la commande %d\n",cmde);
	
	//envoi du numero de commande
	rs232_tx_8(fd,cmde);
	
	//envoi du float associe
	rs232_tx_32(fd,v);
	
	//recup du code retour
	rs232_rx_8(fd,&rec);
	
	fprintf(flog,"retour du µC %d [%x]\n",rec,rec);
	
	//printf("code retour %d\n",rec);
	
	
	return rec;
}

//-----------------------------------------------------------------------
//mesure
//-----------------------------------------------------------------------
int mesure	(	int fd,
				int nmes,
				float _va,
				float _vg2,
				float _vg1,
				float *va_mes,
				float *vg2_mes,
				float *vg1_mes,
				float *ia_mes,
				float *ig2_mes,
				float *ig1_mes
			)
{
	int i;
	float v;
	unsigned char ret;
	unsigned char *addr;
	
	float ia;
	float ig1;
	float ig2;
	float va;
	float vg1;
	float vg2;
	
	
	fprintf(flog,"\ndemande de mesure\n");
	
	//le nombre de moyennes est fixé dans v
	v=(float)nmes;
	
	//on regle les tensions
	envoi_cmde(fd,SET_VA,_va);
	envoi_cmde(fd,SET_VG2,_vg2);
	envoi_cmde(fd,SET_VG1,_vg1);
	ret=envoi_cmde(fd,MESURE,v);
	
	//on recupere les mesures
	rs232_rx_32(fd,&va);		
//	printf("va  = %f\n",va);
	
	rs232_rx_32(fd,&vg2);		
//	printf("vg2  = %f\n",vg2);
	
	rs232_rx_32(fd,&vg1);		
//	printf("vg1  = %f\n",vg1);
	
	rs232_rx_32(fd,&ia);		
//	printf("ia  = %f\n",ia);
	
	rs232_rx_32(fd,&ig2);		
//	printf("ig2  = %f\n",ig2);
	
	rs232_rx_32(fd,&ig1);		
//	printf("ig1  = %f\n",ig1);
	
	
	//on retourne les mesures
	*va_mes=va;
	*vg1_mes=vg1;
	*vg2_mes=vg2;
	*ia_mes=ia;
	*ig1_mes=ig1;
	*ig2_mes=ig2;


	fprintf(flog,"vecteur de mesure retourné par le µC\n");

	//pour avoir une copie des octets envoyés
	addr=(unsigned char*)&va;
	fprintf(flog,"VA = %f [%x %x %x %x]\n",va,*addr,*(addr+1),*(addr+2),*(addr+3));

	addr=(unsigned char*)&vg2;
	fprintf(flog,"VG2 = %f [%x %x %x %x]\n",vg2,*addr,*(addr+1),*(addr+2),*(addr+3));

	addr=(unsigned char*)&vg1;
	fprintf(flog,"VG1 = %f [%x %x %x %x]\n",vg1,*addr,*(addr+1),*(addr+2),*(addr+3));

	addr=(unsigned char*)&ia;
	fprintf(flog,"IA = %f [%x %x %x %x]\n",ia,*addr,*(addr+1),*(addr+2),*(addr+3));

	addr=(unsigned char*)&ig2;
	fprintf(flog,"IG2 = %f [%x %x %x %x]\n",ig2,*addr,*(addr+1),*(addr+2),*(addr+3));

	addr=(unsigned char*)&ig1;
	fprintf(flog,"IG1 = %f [%x %x %x %x]\n",ig1,*addr,*(addr+1),*(addr+2),*(addr+3));


	fprintf(flog,"\n");

	
	return ret;
}









//-----------------------------------------------------------------------
//routines d'emission et de reception sur la rs232
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
bool rs232_tx_8(int fd,unsigned char c)
{
	bool res;
	int ntx;
		
	res=true;
	
	//envoi de la valeur
    ntx=write(fd,&c,1);

   	if (ntx<0)
	{    
		res=false;
	}
	
	return res;
}
//-----------------------------------------------------------------------
bool rs232_rx_8(int fd,unsigned char *c)
{
	bool res;
	int nrx;
	
	res=true;
	
	//lecture de la valeur
	nrx=read(fd,c,1);
	
   	if (nrx<0)
	{    
		res=0;
	}

	return res;
}
//-----------------------------------------------------------------------
//emission 16
bool rs232_tx_16(int fd,int c)
{
	bool res;
	unsigned char msb;
	unsigned char lsb;
	
	//decomposition msb lsb
	msb=c/256;
	lsb=c-msb*256;
	
	res=true;

	//transmission	
	res=res & rs232_tx_8(fd,msb);
	res=res & rs232_tx_8(fd,lsb);
	
	return res;
}
//-----------------------------------------------------------------------
//reception 16
bool rs232_rx_16(int fd,int *c)
{
	bool res;
	unsigned char msb;
	unsigned char lsb;
	
	res=true;

	//transmission	
	res=res & rs232_rx_8(fd,&msb);
	res=res & rs232_rx_8(fd,&lsb);
	
	//recomposition msb lsb
	*c=256*msb+lsb;
	
	return res;
}
//-----------------------------------------------------------------------
//emission 32
bool rs232_tx_32(int fd,float c)
{
	unsigned char *val;
	int i;
	
	val=(unsigned char*)&c;
	
	for (i=0;i<4;i++)
	{
		rs232_tx_8(fd,*val);
		val++;
	}
}
//-----------------------------------------------------------------------
//reception 32
bool rs232_rx_32(int fd,float *c)
{
	unsigned char val;
	unsigned char *ptr;
	int i;
	
	ptr=(unsigned char*)c;
	
	for (i=0;i<4;i++)
	{
		rs232_rx_8(fd,&val);
		*ptr=val;
		ptr++;
	}
}




